OAuth = require 'oauth'
ig = require('instagram-node').instagram()
async = require 'async'
_ = require 'underscore'
config = require '../config'

TW_API_KEY       = process.env.TW_API_KEY or
                   throw new Error "TW_API_KEY environment variable is not defined"

TW_API_SECRET    = process.env.TW_API_SECRET or
                   throw new Error "TW_API_SECRET environment variable is not defined"

TW_FOLLOWING_URL = 'https://api.twitter.com/1.1/friends/list.json'

oauth    = new OAuth.OAuth 'https://api.twitter.com/oauth/request_token',
                           'https://api.twitter.com/oauth/access_token',
                            TW_API_KEY, TW_API_SECRET, '1.0A', null, 'HMAC-SHA1'

twUser = (req, res, next) ->
  username = req.params.user
  getTwFollowing 10, username, req.user.token, req.user.secret, (err, us) ->
    if err? then next err
    else
      json = toJsonTw username, us
      res.send json


user = (req, res, next) ->
  userName = req.params.user
  getTopUsers 10, userName, req.session.token, (err, us) ->
    if err? then next err
    else
      json = toJson userName, us
      res.send json

toJsonTw = (userName, friends) ->
  children = []
  for f in friends
    children.push name: f.screen_name
  {
    name: userName
    children: children
  }

toJson = (userName, friends) ->
  children = []
  for f in friends
    children.push name: f.key
  {
    name: userName
    children: children
  }

addUsersToHash = (memo, data, cb) ->
  userLikes = (user, cb) ->
    userName = user.username
    h = {}
    if memo[userName]?
      memo[userName] += 1
      cb null, memo
    else
      memo[userName] = 1
      cb null, memo

  async.each data.likes.data, userLikes, (err) ->
    if err? then cb err
    else cb null, memo

getTwFollowing = (size, username, userToken, userSecret, cb) ->
  url = "#{TW_FOLLOWING_URL}?screen_name=#{username}&count=#{size}"
  oauth.get url, userToken, userSecret, (e, data, res) ->
    if e then cb e
    else
      feed = JSON.parse data
      cb null, feed.users

getTopUsers = (size, userName, accessToken, cb) ->
  ig.use access_token: accessToken
  ig.user_search userName, (err, users) ->
    if err? then cb err
    else
      if users.length is 0
        []
      else
        userId = users[0].id
        ig.user_media_recent userId, {count: 60}, (err, medias) ->
          if err? then cb err
          else
            users = async.reduce medias, {}, addUsersToHash, (err, usrs) ->
              if err? then cb err
              else cb null, topUsers size, usrs


topUsers = (size, users) ->
  list = []
  if size is 0
    list
  else
    for k, v of users
      if list.length is 0
        list.push {key: k, val: v}
      else if list.length < size
        list.push {key: k, val: v}
        list.sort (a, b) -> b.val - a.val
      else
        list.pop()
        list.push {key: k, val: v}
        list.sort (a, b) -> b.val - a.val

    list.slice 0, size


exports.user = user
exports.twUser = twUser
