TW_CALLBACK_URL = process.env.TW_CALLBACK_URL or
                  throw new Error "TW_CALLBACK_URL environment variable is not defined"

TW_API_KEY      = process.env.TW_API_KEY or
                  throw new Error "TW_API_KEY environment variable is not defined"

TW_API_SECRET   = process.env.TW_API_SECRET or
                  throw new Error "TW_API_SECRET environment variable is not defined"

passport        = require 'passport'
TwitterStrategy = (require 'passport-twitter').Strategy
controllers = require './controllers'

twitterStrategyOptions =
  consumerKey    : TW_API_KEY
  consumerSecret : TW_API_SECRET
  callbackUrl    : TW_CALLBACK_URL

twitterStrategyCallback = (token, tokenSecret, profile, done) ->
  profile.token  = token
  profile.secret = tokenSecret
  process.nextTick () -> done null, profile

strategy = new TwitterStrategy twitterStrategyOptions, twitterStrategyCallback

passport.serializeUser   (user, done) -> done(null, user)
passport.deserializeUser (obj, done)  -> done(null, obj)
passport.use strategy

module.exports = (app) ->

  app.use passport.initialize()
  app.use passport.session()

  app.get '/', (req, res, next) ->
    controllers.example.index req, res, next

  app.get '/auth', controllers.auth.authorize
  app.get '/auth/redirect', controllers.auth.redirect

  app.get '/auth/twitter', passport.authenticate 'twitter', (req, res) -> {}

  app.get '/auth/twitter/callback', passport.authenticate('twitter', failureRedirect: '/'),
         (req, res) ->
            console.log req.user
            res.redirect "/tw/graph/tree/#{req.user.username}"

  app.get '/graph/tree/:user', controllers.example.tree

  app.get '/tw/graph/tree/:user', controllers.example.tree

  app.get '/api/user/:user', controllers.user.user

  app.get '/api/tw/user/:user', controllers.user.twUser
